<?php
/**
 * Dupechecker Version 1.1
 * 
 * Plugin written by Jayhunter for
 * 
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 **************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 **************************************************
 */
 

if (!defined('IN_COPPERMINE')) { 
    die('Not in Coppermine...');
}
require_once('./plugins/dupechecker/init.inc.php');


$thisplugin->add_action('upload_swf_pre_move','md5_dupe_check_swf');
$thisplugin->add_action('upload_html_pre_move','md5_dupe_check_html');

function md5_dupe_check_swf($path_to_image) {
    global $CONFIG, $dupechecker_lang;
    $md5 = md5_file ($path_to_image);
    $filesize = filesize($path_to_image);
    $res = cpg_db_query ("SELECT md5, filesize FROM {$CONFIG['TABLE_PICTURES']} WHERE md5='{$md5}' AND filesize = '{$filesize}'");
    if ($res->numRows()>0) {
        echo "error|{$dupechecker_lang['file_exists']}|0";
        exit;
    }
    return false;
}
function md5_dupe_check_html($path_to_image) {
    global $CONFIG, $dupechecker_lang;
    $md5 = md5_file ($path_to_image);
    $filesize = filesize($path_to_image);
    $res = cpg_db_query ("SELECT md5, filesize FROM {$CONFIG['TABLE_PICTURES']} WHERE md5='{$md5}' AND filesize = '{$filesize}'");
    if ($res->numRows()>0) {
        cpg_die(ERROR, $dupechecker_lang['file_exists'], __FILE__, __LINE__);
    }
    return false;
}

$thisplugin->add_action('add_file_data_success','add_md5');

function add_md5 ($CURRENT_PIC_DATA) {
    global $CONFIG;
    $md5 = md5_file ($CONFIG['fullpath'] . $CURRENT_PIC_DATA['filepath'] . $CURRENT_PIC_DATA['filename']);

    cpg_db_query("UPDATE {$CONFIG['TABLE_PICTURES']} SET md5='{$md5}' WHERE pid ={$CURRENT_PIC_DATA['pid']}");
}






$thisplugin->add_action('plugin_install','dupecheck_install');
$thisplugin->add_action('plugin_uninstall','dupecheck_uninstall');    

// Install the plugin
function dupecheck_install() {
    global $CONFIG;
    $query = "ALTER TABLE `{$CONFIG['TABLE_PICTURES']}` ADD `md5` CHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL AFTER `filesize`";
    cpg_db_query($query);
    return true;
}

// Uninstall the plugin
function dupecheck_uninstall() {
    global $CONFIG;
    $query = "ALTER TABLE `{$CONFIG['TABLE_PICTURES']}` DROP `md5`";
    cpg_db_query($query);
    return true;
}  